package devices

import "sync"

func NewTest(status bool) Device {
	device := &test{
		lock:   sync.Mutex{},
		status: status,
	}
	return device
}

type test struct {
	lock   sync.Mutex
	status bool
}

func (d *test) Status() (bool, error) {
	d.lock.Lock()
	defer d.lock.Unlock()

	return d.status, nil
}

func (d *test) ToggleStatus() error {
	d.lock.Lock()
	defer d.lock.Unlock()

	d.status = !d.status
	return nil
}
